/*
lightOS kernel
Copyright (C) 2007-2009 Jörg Pfähler

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
*/
#include <kernel/x86_shared/idt.hpp>
using namespace kernel;

extern "C"
{
	void interrupt0();
	void interrupt1();
	void interrupt2();
	void interrupt3();
	void interrupt4();
	void interrupt5();
	void interrupt6();
	void interrupt7();
	void interrupt8();
	void interrupt9();
	void interrupt10();
	void interrupt11();
	void interrupt12();
	void interrupt13();
	void interrupt14();
	void interrupt15();
	void interrupt16();
	void interrupt17();
	void interrupt18();
	void interrupt19();
	void interrupt20();
	void interrupt21();
	void interrupt22();
	void interrupt23();
	void interrupt24();
	void interrupt25();
	void interrupt26();
	void interrupt27();
	void interrupt28();
	void interrupt29();
	void interrupt30();
	void interrupt31();
	void interrupt32();
	void interrupt33();
	void interrupt34();
	void interrupt35();
	void interrupt36();
	void interrupt37();
	void interrupt38();
	void interrupt39();
	void interrupt40();
	void interrupt41();
	void interrupt42();
	void interrupt43();
	void interrupt44();
	void interrupt45();
	void interrupt46();
	void interrupt47();
	#ifdef _LIGHTOS_SMP
		void interrupt48();
		void interrupt49();
		void interrupt50();
		void interrupt51();
		void interrupt52();
		void interrupt53();
		void interrupt54();
		void interrupt55();
		void interrupt56();
		void interrupt57();
		void interrupt58();
		void interrupt59();
		void interrupt60();
		void interrupt61();
		void interrupt62();
		void interrupt63();
		void interrupt64();
		void interrupt65();
		void interrupt66();
		void interrupt67();
		void interrupt68();
		void interrupt69();
		void interrupt70();
		void interrupt71();
		void interrupt72();
		void interrupt73();
		void interrupt74();
		void interrupt75();
		void interrupt76();
		void interrupt77();
		void interrupt78();
		void interrupt79();
		void interrupt80();
		void interrupt81();
		void interrupt82();
		void interrupt83();
		void interrupt84();
		void interrupt85();
		void interrupt86();
		void interrupt87();
		void interrupt88();
		void interrupt89();
		void interrupt90();
		void interrupt91();
		void interrupt92();
		void interrupt93();
		void interrupt94();
		void interrupt95();
		void interrupt96();
		void interrupt97();
		void interrupt98();
		void interrupt99();
		void interrupt100();
		void interrupt101();
		void interrupt102();
		void interrupt103();
		void interrupt104();
		void interrupt105();
		void interrupt106();
		void interrupt107();
		void interrupt108();
		void interrupt109();
		void interrupt110();
		void interrupt111();
		void interrupt112();
		void interrupt113();
		void interrupt114();
		void interrupt115();
		void interrupt116();
		void interrupt117();
		void interrupt118();
		void interrupt119();
		void interrupt120();
		void interrupt121();
		void interrupt122();
		void interrupt123();
		void interrupt124();
		void interrupt125();
		void interrupt126();
		void interrupt127();
		void interrupt128();
		void interrupt129();
		void interrupt130();
		void interrupt131();
		void interrupt132();
		void interrupt133();
		void interrupt134();
		void interrupt135();
		void interrupt136();
		void interrupt137();
		void interrupt138();
		void interrupt139();
		void interrupt140();
		void interrupt141();
		void interrupt142();
		void interrupt143();
		void interrupt144();
		void interrupt145();
		void interrupt146();
		void interrupt147();
		void interrupt148();
		void interrupt149();
		void interrupt150();
		void interrupt151();
		void interrupt152();
		void interrupt153();
		void interrupt154();
		void interrupt155();
		void interrupt156();
		void interrupt157();
		void interrupt158();
		void interrupt159();
		void interrupt160();
		void interrupt161();
		void interrupt162();
		void interrupt163();
		void interrupt164();
		void interrupt165();
		void interrupt166();
		void interrupt167();
		void interrupt168();
		void interrupt169();
		void interrupt170();
		void interrupt171();
		void interrupt172();
		void interrupt173();
		void interrupt174();
		void interrupt175();
		void interrupt176();
		void interrupt177();
		void interrupt178();
		void interrupt179();
		void interrupt180();
		void interrupt181();
		void interrupt182();
		void interrupt183();
		void interrupt184();
		void interrupt185();
		void interrupt186();
		void interrupt187();
		void interrupt188();
		void interrupt189();
		void interrupt190();
		void interrupt191();
		void interrupt192();
		void interrupt193();
		void interrupt194();
		void interrupt195();
		void interrupt196();
		void interrupt197();
		void interrupt198();
		void interrupt199();
		void interrupt200();
		void interrupt201();
		void interrupt202();
		void interrupt203();
		void interrupt204();
		void interrupt205();
		void interrupt206();
		void interrupt207();
		void interrupt208();
		void interrupt209();
		void interrupt210();
		void interrupt211();
		void interrupt212();
		void interrupt213();
		void interrupt214();
		void interrupt215();
		void interrupt216();
		void interrupt217();
		void interrupt218();
		void interrupt219();
		void interrupt220();
		void interrupt221();
		void interrupt222();
		void interrupt223();
		void interrupt224();
		void interrupt225();
		void interrupt226();
		void interrupt227();
		void interrupt228();
		void interrupt229();
		void interrupt230();
		void interrupt231();
		void interrupt232();
		void interrupt233();
		void interrupt234();
		void interrupt235();
		void interrupt236();
		void interrupt237();
		void interrupt238();
		void interrupt239();
		void interrupt240();
		void interrupt241();
		void interrupt242();
		void interrupt243();
		void interrupt244();
		void interrupt245();
		void interrupt246();
		void interrupt247();
		void interrupt248();
		void interrupt249();
		void interrupt250();
		void interrupt251();
		void interrupt252();
		void interrupt253();
	#endif
	void interrupt255();
}

idt idt::mInst;

void idt::init()
{
	set_interrupt_gate(0, interrupt0);
	set_interrupt_gate(1, interrupt1);
	set_interrupt_gate(2, interrupt2);
	set_interrupt_gate(3, interrupt3);
	set_interrupt_gate(4, interrupt4);
	set_interrupt_gate(5, interrupt5);
	set_interrupt_gate(6, interrupt6);
	set_interrupt_gate(7, interrupt7);
	set_interrupt_gate(8, interrupt8);
	set_interrupt_gate(9, interrupt9);
	set_interrupt_gate(10, interrupt10);
	set_interrupt_gate(11, interrupt11);
	set_interrupt_gate(12, interrupt12);
	set_interrupt_gate(13, interrupt13);
	set_interrupt_gate(14, interrupt14);
	set_interrupt_gate(15, interrupt15);
	set_interrupt_gate(16, interrupt16);
	set_interrupt_gate(17, interrupt17);
	set_interrupt_gate(18, interrupt18);
	set_interrupt_gate(19, interrupt19);
	set_interrupt_gate(20, interrupt20);
	set_interrupt_gate(21, interrupt21);
	set_interrupt_gate(22, interrupt22);
	set_interrupt_gate(23, interrupt23);
	set_interrupt_gate(24, interrupt24);
	set_interrupt_gate(25, interrupt25);
	set_interrupt_gate(26, interrupt26);
	set_interrupt_gate(27, interrupt27);
	set_interrupt_gate(28, interrupt28);
	set_interrupt_gate(29, interrupt29);
	set_interrupt_gate(30, interrupt30);
	set_interrupt_gate(31, interrupt31);
	set_interrupt_gate(32, interrupt32);
	set_interrupt_gate(33, interrupt33);
	set_interrupt_gate(34, interrupt34);
	set_interrupt_gate(35, interrupt35);
	set_interrupt_gate(36, interrupt36);
	set_interrupt_gate(37, interrupt37);
	set_interrupt_gate(38, interrupt38);
	set_interrupt_gate(39, interrupt39);
	set_interrupt_gate(40, interrupt40);
	set_interrupt_gate(41, interrupt41);
	set_interrupt_gate(42, interrupt42);
	set_interrupt_gate(43, interrupt43);
	set_interrupt_gate(44, interrupt44);
	set_interrupt_gate(45, interrupt45);
	set_interrupt_gate(46, interrupt46);
	set_interrupt_gate(47, interrupt47);
	#ifdef _LIGHTOS_SMP
		set_interrupt_gate(48, interrupt48);
		set_interrupt_gate(49, interrupt49);
		set_interrupt_gate(50, interrupt50);
		set_interrupt_gate(51, interrupt51);
		set_interrupt_gate(52, interrupt52);
		set_interrupt_gate(53, interrupt53);
		set_interrupt_gate(54, interrupt54);
		set_interrupt_gate(55, interrupt55);
		set_interrupt_gate(56, interrupt56);
		set_interrupt_gate(57, interrupt57);
		set_interrupt_gate(58, interrupt58);
		set_interrupt_gate(59, interrupt59);
		set_interrupt_gate(60, interrupt60);
		set_interrupt_gate(61, interrupt61);
		set_interrupt_gate(62, interrupt62);
		set_interrupt_gate(63, interrupt63);
		set_interrupt_gate(64, interrupt64);
		set_interrupt_gate(65, interrupt65);
		set_interrupt_gate(66, interrupt66);
		set_interrupt_gate(67, interrupt67);
		set_interrupt_gate(68, interrupt68);
		set_interrupt_gate(69, interrupt69);
		set_interrupt_gate(70, interrupt70);
		set_interrupt_gate(71, interrupt71);
		set_interrupt_gate(72, interrupt72);
		set_interrupt_gate(73, interrupt73);
		set_interrupt_gate(74, interrupt74);
		set_interrupt_gate(75, interrupt75);
		set_interrupt_gate(76, interrupt76);
		set_interrupt_gate(77, interrupt77);
		set_interrupt_gate(78, interrupt78);
		set_interrupt_gate(79, interrupt79);
		set_interrupt_gate(80, interrupt80);
		set_interrupt_gate(81, interrupt81);
		set_interrupt_gate(82, interrupt82);
		set_interrupt_gate(83, interrupt83);
		set_interrupt_gate(84, interrupt84);
		set_interrupt_gate(85, interrupt85);
		set_interrupt_gate(86, interrupt86);
		set_interrupt_gate(87, interrupt87);
		set_interrupt_gate(88, interrupt88);
		set_interrupt_gate(89, interrupt89);
		set_interrupt_gate(90, interrupt90);
		set_interrupt_gate(91, interrupt91);
		set_interrupt_gate(92, interrupt92);
		set_interrupt_gate(93, interrupt93);
		set_interrupt_gate(94, interrupt94);
		set_interrupt_gate(95, interrupt95);
		set_interrupt_gate(96, interrupt96);
		set_interrupt_gate(97, interrupt97);
		set_interrupt_gate(98, interrupt98);
		set_interrupt_gate(99, interrupt99);
		set_interrupt_gate(100, interrupt100);
		set_interrupt_gate(101, interrupt101);
		set_interrupt_gate(102, interrupt102);
		set_interrupt_gate(103, interrupt103);
		set_interrupt_gate(104, interrupt104);
		set_interrupt_gate(105, interrupt105);
		set_interrupt_gate(106, interrupt106);
		set_interrupt_gate(107, interrupt107);
		set_interrupt_gate(108, interrupt108);
		set_interrupt_gate(109, interrupt109);
		set_interrupt_gate(110, interrupt110);
		set_interrupt_gate(111, interrupt111);
		set_interrupt_gate(112, interrupt112);
		set_interrupt_gate(113, interrupt113);
		set_interrupt_gate(114, interrupt114);
		set_interrupt_gate(115, interrupt115);
		set_interrupt_gate(116, interrupt116);
		set_interrupt_gate(117, interrupt117);
		set_interrupt_gate(118, interrupt118);
		set_interrupt_gate(119, interrupt119);
		set_interrupt_gate(120, interrupt120);
		set_interrupt_gate(121, interrupt121);
		set_interrupt_gate(122, interrupt122);
		set_interrupt_gate(123, interrupt123);
		set_interrupt_gate(124, interrupt124);
		set_interrupt_gate(125, interrupt125);
		set_interrupt_gate(126, interrupt126);
		set_interrupt_gate(127, interrupt127);
		set_interrupt_gate(128, interrupt128);
		set_interrupt_gate(129, interrupt129);
		set_interrupt_gate(130, interrupt130);
		set_interrupt_gate(131, interrupt131);
		set_interrupt_gate(132, interrupt132);
		set_interrupt_gate(133, interrupt133);
		set_interrupt_gate(134, interrupt134);
		set_interrupt_gate(135, interrupt135);
		set_interrupt_gate(136, interrupt136);
		set_interrupt_gate(137, interrupt137);
		set_interrupt_gate(138, interrupt138);
		set_interrupt_gate(139, interrupt139);
		set_interrupt_gate(140, interrupt140);
		set_interrupt_gate(141, interrupt141);
		set_interrupt_gate(142, interrupt142);
		set_interrupt_gate(143, interrupt143);
		set_interrupt_gate(144, interrupt144);
		set_interrupt_gate(145, interrupt145);
		set_interrupt_gate(146, interrupt146);
		set_interrupt_gate(147, interrupt147);
		set_interrupt_gate(148, interrupt148);
		set_interrupt_gate(149, interrupt149);
		set_interrupt_gate(150, interrupt150);
		set_interrupt_gate(151, interrupt151);
		set_interrupt_gate(152, interrupt152);
		set_interrupt_gate(153, interrupt153);
		set_interrupt_gate(154, interrupt154);
		set_interrupt_gate(155, interrupt155);
		set_interrupt_gate(156, interrupt156);
		set_interrupt_gate(157, interrupt157);
		set_interrupt_gate(158, interrupt158);
		set_interrupt_gate(159, interrupt159);
		set_interrupt_gate(160, interrupt160);
		set_interrupt_gate(161, interrupt161);
		set_interrupt_gate(162, interrupt162);
		set_interrupt_gate(163, interrupt163);
		set_interrupt_gate(164, interrupt164);
		set_interrupt_gate(165, interrupt165);
		set_interrupt_gate(166, interrupt166);
		set_interrupt_gate(167, interrupt167);
		set_interrupt_gate(168, interrupt168);
		set_interrupt_gate(169, interrupt169);
		set_interrupt_gate(170, interrupt170);
		set_interrupt_gate(171, interrupt171);
		set_interrupt_gate(172, interrupt172);
		set_interrupt_gate(173, interrupt173);
		set_interrupt_gate(174, interrupt174);
		set_interrupt_gate(175, interrupt175);
		set_interrupt_gate(176, interrupt176);
		set_interrupt_gate(177, interrupt177);
		set_interrupt_gate(178, interrupt178);
		set_interrupt_gate(179, interrupt179);
		set_interrupt_gate(180, interrupt180);
		set_interrupt_gate(181, interrupt181);
		set_interrupt_gate(182, interrupt182);
		set_interrupt_gate(183, interrupt183);
		set_interrupt_gate(184, interrupt184);
		set_interrupt_gate(185, interrupt185);
		set_interrupt_gate(186, interrupt186);
		set_interrupt_gate(187, interrupt187);
		set_interrupt_gate(188, interrupt188);
		set_interrupt_gate(189, interrupt189);
		set_interrupt_gate(190, interrupt190);
		set_interrupt_gate(191, interrupt191);
		set_interrupt_gate(192, interrupt192);
		set_interrupt_gate(193, interrupt193);
		set_interrupt_gate(194, interrupt194);
		set_interrupt_gate(195, interrupt195);
		set_interrupt_gate(196, interrupt196);
		set_interrupt_gate(197, interrupt197);
		set_interrupt_gate(198, interrupt198);
		set_interrupt_gate(199, interrupt199);
		set_interrupt_gate(200, interrupt200);
		set_interrupt_gate(201, interrupt201);
		set_interrupt_gate(202, interrupt202);
		set_interrupt_gate(203, interrupt203);
		set_interrupt_gate(204, interrupt204);
		set_interrupt_gate(205, interrupt205);
		set_interrupt_gate(206, interrupt206);
		set_interrupt_gate(207, interrupt207);
		set_interrupt_gate(208, interrupt208);
		set_interrupt_gate(209, interrupt209);
		set_interrupt_gate(210, interrupt210);
		set_interrupt_gate(211, interrupt211);
		set_interrupt_gate(212, interrupt212);
		set_interrupt_gate(213, interrupt213);
		set_interrupt_gate(214, interrupt214);
		set_interrupt_gate(215, interrupt215);
		set_interrupt_gate(216, interrupt216);
		set_interrupt_gate(217, interrupt217);
		set_interrupt_gate(218, interrupt218);
		set_interrupt_gate(219, interrupt219);
		set_interrupt_gate(220, interrupt220);
		set_interrupt_gate(221, interrupt221);
		set_interrupt_gate(222, interrupt222);
		set_interrupt_gate(223, interrupt223);
		set_interrupt_gate(224, interrupt224);
		set_interrupt_gate(225, interrupt225);
		set_interrupt_gate(226, interrupt226);
		set_interrupt_gate(227, interrupt227);
		set_interrupt_gate(228, interrupt228);
		set_interrupt_gate(229, interrupt229);
		set_interrupt_gate(230, interrupt230);
		set_interrupt_gate(231, interrupt231);
		set_interrupt_gate(232, interrupt232);
		set_interrupt_gate(233, interrupt233);
		set_interrupt_gate(234, interrupt234);
		set_interrupt_gate(235, interrupt235);
		set_interrupt_gate(236, interrupt236);
		set_interrupt_gate(237, interrupt237);
		set_interrupt_gate(238, interrupt238);
		set_interrupt_gate(239, interrupt239);
		set_interrupt_gate(240, interrupt240);
		set_interrupt_gate(241, interrupt241);
		set_interrupt_gate(242, interrupt242);
		set_interrupt_gate(243, interrupt243);
		set_interrupt_gate(244, interrupt244);
		set_interrupt_gate(245, interrupt245);
		set_interrupt_gate(246, interrupt246);
		set_interrupt_gate(247, interrupt247);
		set_interrupt_gate(248, interrupt248);
		set_interrupt_gate(249, interrupt249);
		set_interrupt_gate(250, interrupt250);
		set_interrupt_gate(251, interrupt251);
		set_interrupt_gate(252, interrupt252);
		set_interrupt_gate(253, interrupt253);
	#endif
	#ifdef X86
		set_userspace_interrupt_gate(255, interrupt255);
	#endif
	#ifdef X86_64
		set_interrupt_gate(255, interrupt255);
	#endif
}

void kernel::initialize_idt()
{
	idt &Idt = idt::instance();
	Idt.init();
	Idt.load();
}
